#ifndef __userfunc_h
#define __userfunc_h
#if defined(BUILD_DLL)
#  define DLL_EXP __declspec(dllexport)
#else
# if defined(BUILD_APP)
#  define DLL_EXP __declspec(dllimport)
# else
#  define DLL_EXP
# endif
#endif
#include <windows.h>
//---------------------------------------------------------
#define protASCII 1
#define protMODBUS 2
//---------------------------------------------------------
//  
#define HMIEnhancedModes
#include "releases.txt"

extern "C"
{

//--------------------------------------------------------------------
void ProtocolInit(); //   
void ProtocolDone(); //    
//--------------------------------------------------------------------
int ProtocolSwitch(int protocol);
int DLL_EXP DllVer();

//--------------------------------------------------------------------
//********************************************************************
/*******************************************************************************************************************************************/

        	int   DLL_EXP   OpenPort(unsigned char cport, DWORD baud, unsigned char data, unsigned char parity, unsigned char stop,unsigned int ReadTimeout,int *error);
/*        COM-.
         :
        cport -  - (1-4);
        baud -  - (300,600,1200,2400,4800,9600,19200,38400,57600,19200 );
        data -   (7,8 );
        parity -  (0-NONE,1 - EVEN,3 - ODD);
        stop -   (0 - 1 ,1- 1.5 ,2 - 2  );
        ReadTimeout -    ms (10....1000);
         :
        *error -    ,       
          :
         -   int   .
*/
/*******************************************************************************************************************************************/

	  int	 DLL_EXP	 ClosePort(int rethan, int *error);
/*        COM-.
         :
        rethan -    -.
         :
        *error -    ,       
*/
/*******************************************************************************************************************************************/
         void	DLL_EXP	 Echo(int porthandle,int *error);
/*       COM-   - .       (TX->RX)
         :
        porthandle -    -.
         :
        *error -    ,       
*/

/*******************************************************************************************************************************************/
#define ToolModes
void	DLL_EXP	 PSend(int rethan,unsigned char *Buf,unsigned int Count,bool CrcEn,int *error);


/*******************************************************************************************************************************************/
void	DLL_EXP	 PRead(int rethan,unsigned char *Buf,unsigned int *Count,bool CrcEn,int *error);
/*******************************************************************************************************************************************/

          void	DLL_EXP	 ReadModuleName(int porthandle,\
                                        unsigned char addr,\
                                        char *Name,\
                                        bool crc,\
                                        int *error);
/*        
         :
        porthandle -    -.
        addr -   0-255.
        crc -     .
         :
        *error -    ,       
        *Name -    ,     
*/
/*******************************************************************************************************************************************/
          void	 DLL_EXP	 ReadModuleFirmVer(int porthandle,\
                                        unsigned char addr,\
                                        char *Ver,\
                                        bool crc,\
                                        int *error);
/*        
         :
        porthandle -    -.
        addr -   0-255.
        crc -     .
         :
        *error -    ,       
        *Ver -    ,     
*/
/*******************************************************************************************************************************************/
          void	DLL_EXP	 ReadModuleSerialNum(int porthandle,\
                                        unsigned char addr,\
                                        char *Num,\
                                        bool crc,\
                                        int *error);
/*        
         :
        porthandle -    -.
        addr -   0-255.
        crc -     .
         :
        *error -    ,       
        *Num -    ,     
*/
/*******************************************************************************************************************************************/
          void	 DLL_EXP	 ReadConfig(int porthandle,\
                                        unsigned char addr,\
                                        unsigned char *Maddr,\
                                        char *MCodeH,\
                                        char *MCodeL,\
                                        DWORD *Baud,\
                                        bool *CheckSumOn,\
                                        bool crc,\
                                        int *error);
/*           
          :
        porthandle -    -.
        addr -   
         crc -       .
         :
        *Maddr - 
        *MCodeH,*MCodeL -   .  ASCII  
        *Baud   -  
        *CheckSumOn  - a   .
        *error -    ,       

*/

/*******************************************************************************************************************************************/
          void	 DLL_EXP	 HMIWriteLcd(int porthandle,\
                                        unsigned char addr,\
                                        char X,\
                                        char Y,\
                                        char *Str,\
                                        bool crc,\
                                        int *error);
 /*           
         :
        porthandle -    -.
        addr -   0-255.
        X -     (0-39)
        Y -  (0-3)
        *Str -   ,  
        crc -     .
         :
        *error -    ,       

*/
/*******************************************************************************************************************************************/
          void	DLL_EXP HMISetCursorPos(int porthandle,\
                                        unsigned char addr,\
                                        unsigned char X,\
                                        unsigned char Y,\
                                        bool crc,\
                                        int *error);
/*         
         :
        porthandle -    -.
        addr -   0-255.
        X -     (0-39)
        Y -  (0-3)
        crc -     .
         :
        *error -    ,       

*/
/*******************************************************************************************************************************************/
          void	DLL_EXP HMIClearLcd(int porthandle,\
                                        unsigned char addr,\
                                        bool crc,\
                                        int *error);
/*       
         :
        porthandle -    -.
        addr -   0-255.
        crc -     .
         :
        *error -    ,       

*/
/*******************************************************************************************************************************************/
          void	 DLL_EXP	 HMISetActiveCodepage(int porthandle,\
                                        unsigned char addr,\
                                        unsigned char Codepage,\
                                        bool crc,\
                                        int *error);
/*          
         :
        porthandle -    -.
        addr -   0-255.
        Codepage -   (0 - 1251 , 1 - 666)
        crc -     .
         :
        *error -    ,       

*/
/*******************************************************************************************************************************************/
          void	 DLL_EXP	 HMIReplaseOneUkrChar(int porthandle,\
                                        unsigned char addr,\
                                        unsigned char CharAddr,\
                                        char Char,\
                                        bool crc,\
                                        int *error);
/*           
            LCD  
        ,      .
         :
        porthandle -    -.
        addr -   0-255.
        CharAddr -    (0..7).
        Char -   .       
          '',     Flash 
        crc -     .
         :
        *error -    ,       

*/
/*******************************************************************************************************************************************/
          void	  DLL_EXP	 HMIReplaseAllUkrChar(int porthandle,\
                                        unsigned char addr,\
                                        unsigned char *Chars,\
                                        bool crc,\
                                        int *error);

  /*            
             LCD  
        ,      .
         :
        porthandle -    -.
        addr -   0-255.
        Chars -    ,     
            ''.  Chars =0 ,      ''
        crc -     .
         :
        *error -    ,       

*/
/*******************************************************************************************************************************************/
          void	 DLL_EXP	 HMISetCharPattern(int porthandle,\
                                        unsigned char addr,\
                                        unsigned char CharAddr,\
                                        char Char,\
                                        unsigned char (*CharPatterns)[5],\
                                        bool crc,\
                                        int *error);
/*            .
         :
        porthandle -    -.
        addr -   0-255.
        CharAddr -    (0..7).
        Char -  ,       .
          = 0 ,    .
        CharPatterns-     array[8][5],    .
            [0][0] -    .
            : 0 -   , 1 -  .
        crc -     .
         :
        *error -    ,       

*/

/*******************************************************************************************************************************************/
          void DLL_EXP	 HMIDisplayMode(int porthandle,\
                                        unsigned char addr,\
                                        bool Blinc,\
                                        bool Static,\
                                        bool On,\
                                        bool EESave,\
                                        bool crc,\
                                        int *error);


/*        .      LCD ,   .
         :
        porthandle -    -.
        addr -   0-255.
        Blinc  - /  
        Static - /  
        On     - / 
        EESave - /    EEPROM
        crc -     .
         :
        *error -    ,       

*/
/*******************************************************************************************************************************************/
          void	DLL_EXP	 HMIBackLight(int porthandle,\
                                        unsigned char addr,\
                                        unsigned char mode,\
                                        bool crc,\
                                        int *error);
/*        
         :
        porthandle -    -.
        addr -  
        mode -  . 0 - . 1 - . (       : 0- , 15-  )
        crc -     .
         :
        *error -    ,       

*/
/*******************************************************************************************************************************************/

/*         void	DLL_EXP	 HMIBackLightMode(int porthandle,\
                                        unsigned char addr,\
                                        unsigned char mode,\
                                        bool crc,\
                                        int *error)
        /    
         :
        porthandle -    -.
        addr -  
        mode -  . 1 - . 0 - .
        crc -     .
         :
        *error -    ,       

*/
/*******************************************************************************************************************************************/
          void	DLL_EXP	 HMIReadKbd(int porthandle,\
                                        unsigned char addr,\
                                        unsigned char *Buf,\
                                        unsigned char *NKeys,\
                                        bool convert,\
                                        bool crc,\
                                        int *error);
/*        
         :
        porthandle -    -.
        addr -  
        crc -     .
         :
        *Buf -    (16),   -
        *NKeys - - -  
        convert - 0- -      ,  HMI   ASCII, 1- -//-   MODBUS
        *error -    ,       
        :
        ASCII -   :
                                 1, 2, 3, 4, 5,
                                 7, 8, 9, 10,11,
                                 13,14,15,16,17,
                                 19,20,21,22,23
        ODBUS -   :
                                 0x11,0x12,0x13,0x14,0x15,
                                 0x21,0x22,0x23,0x24,0x25,
                                 0x31,0x32,0x33,0x34,0x35,
                                 0x41,0x42,0x43,0x44,0x45
*/
/*******************************************************************************************************************************************/
          void	 DLL_EXP	 HMISetDO(int porthandle,\
                                        unsigned char addr,\
                                        unsigned char DO,\
                                        bool shift,\
                                        bool crc,\
                                        int *error);
/*         :
         :
        porthandle -    -.
        addr -  
        DO -   (0-255);
        shift -
             1-   4/4      [4..7]
             0-  
        crc -     .
         :
        *error -    ,       

*/
/*******************************************************************************************************************************************/
          void	 DLL_EXP	 HMIReadDI(int porthandle,\
                                        unsigned char addr,\
                                        unsigned char *DI,\
                                        bool crc,\
                                        int *error);
/*         :
         :
        porthandle -    -.
        addr -  
        crc -     .
         :
        *DI -   ,    
        *error -    ,       

*/
/*******************************************************************************************************************************************/
          void	 DLL_EXP	 HMIChangeAddrBaud(int porthandle,\
                                        unsigned char addr,\
                                        unsigned char NewAddr,\
                                        DWORD NewBaud,\
                                        bool CheckSumOn,\
                                        bool crc,\
                                        int *error);
/*         .
         ,  ,  ,      :
         :
        porthandle -    -.
        addr -   
        NewAddr   -   
        NewBaud   -   
        CheckSumOn  -    .
        crc -       .
         :
        *error -    ,       
        :    = -2 ,       

*/

/*******************************************************************************************************************************************/
          void	 DLL_EXP	 SynchroniseSample(int porthandle,\
                                                bool crc,\
                                                int *error);
/*        .
         :
        porthandle -    -.
        crc -       .
         :
        *error -    ,       
*/

/*******************************************************************************************************************************************/
          void	 DLL_EXP	 HMIReadSynchroniseSample(int porthandle,\
                                        unsigned char addr,\
                                        unsigned char *SD,\
                                        bool *FirstRead,\
                                        bool crc,\
                                        int *error);
/*         
         :
        porthandle -    -.
        crc -       .
         :
        *SD       -    ,    
        *FirstRead - ,    
        *error -    ,       
*/
/*******************************************************************************************************************************************/
          void	DLL_EXP HMIReadConfig(int porthandle,\
                                        unsigned char addr,\
                                        unsigned char *Maddr,\
                                        DWORD *Baud,\
                                        bool *CheckSumOn,\
                                        bool crc,\
                                        int *error);
/*           
          :
        porthandle -    -.
        addr -   
         crc -       .
         :
        *Maddr - 
        *Baud   -  
        *CheckSumOn  - a   .
        *error -    ,       

*/
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



void	DLL_EXP	 HMIBackLightMode(int porthandle,\
                                        unsigned char addr,\
                                        unsigned char mode,\
                                        bool crc,\
                                        int *error);
/*         
         :
        porthandle -    -.
        mode -  . 1 - . 0 - .
        crc -     .
         :
        *error -    ,       

*/

/*******************************************************************************************************************************************/
        void	DLL_EXP	  HMIKbdBeep(int porthandle,\
                                        unsigned char addr,\
                                        bool Enable,\
                                        bool crc,\
                                        int *error);

/*       /    
         :
        porthandle -    -.
        addr -   
        Enable - no comments :-)
        crc -       .
         :
        *error -    ,       
*/
/*******************************************************************************************************************************************/
        void	DLL_EXP	  HMIBeep(int porthandle,\
                                        unsigned char addr,\
                                        unsigned int Freq,\
                                        bool crc,\
                                        int *error);
/*        
         :
        porthandle -    -.
        addr -   
        Freq -    10 - 10. 0 - 
        crc -       .
         :
        *error -    ,       
*/
/*******************************************************************************************************************************************/
        void	DLL_EXP	  HMISetKBBufSize(int porthandle,\
                                        unsigned char addr,\
                                        bool Large,\
                                        bool crc,\
                                        int *error);
 /*         
         :
        porthandle -    -.
        addr -   
        Large -  -  32 ,  8
        crc -       .
         :
        *error -    ,       
*/
/*******************************************************************************************************************************************/
/*******************************************************************************************************************************************/
        void	DLL_EXP	  HMISetUserLed(int porthandle,\
                                        unsigned char addr,\
                                        bool On,\
                                        bool crc,\
                                        int *error);
/*       -   
         :
        porthandle -    -.
        addr -   
        On -  -  ,  
        crc -       .
         :
        *error -    ,       
*/

/*******************************************************************************************************************************************/

/*******************************************************************************************************************************************/
          void	DLL_EXP	 ReadModuleStatus(int porthandle,\
                                        unsigned char addr,\
                                        unsigned char *Status,\
                                        bool crc,\
                                        int *error);
/*        .
         :
        porthandle -    -.
        addr -   
         crc -       .
         :
        *error -    ,       
        *Status -  (0 - , 1 -  )
*/

/*******************************************************************************************************************************************/
          void DLL_EXP	 ResetModuleStatus(int porthandle,\
                                        unsigned char addr,\
                                        bool crc,\
                                        int *error);

/*        .
         :
        porthandle -    -.
        addr -   
         crc -       .
         :
        *error -    ,       

*/
/*******************************************************************************************************************************************/
          void	 DLL_EXP	  ReadWDTValue(int porthandle,\
                                        unsigned char addr,\
                                        unsigned char *Value,\
                                        bool *Status,\
                                        bool crc,\
                                        int *error);
/*          .
         :
        porthandle -    -.
        addr -   
         crc -       .
         :
        *Status -  -  
        *Value -  
        *error -    ,       

*/
/*******************************************************************************************************************************************/
          void	 DLL_EXP	  SetWDTValue(int porthandle,\
                                        unsigned char addr,\
                                        unsigned char Value,\
                                        bool Status,\
                                        bool crc,\
                                        int *error);
/*              .
         :
        porthandle -    -.
        addr -   
        Status -  -  
        Value -   (0..255)  0.1 - 25.5 
        crc -       .
         :
        *error -    ,       
        :    = -2 ,       
*/
/*******************************************************************************************************************************************/
          void	 DLL_EXP	  SetSafePupValue(int porthandle,\
                                        unsigned char addr,\
                                        bool Status,\
                                        bool crc,\
                                        int *error);
 /*       /    
         :
        porthandle -    -.
        addr -   
        Status -  -    ,  - 
        crc -       .
         :
        *error -    ,       
*/
/*******************************************************************************************************************************************/
          void	 DLL_EXP	  HostOK(int porthandle,\
                                                bool crc,\
                                                int *error);
/*         .
         :
        porthandle -    -.
        crc -       .
         :
        *error -    ,       
*/
/*******************************************************************************************************************************************/
          void	DLL_EXP  SetModuleName(int porthandle,\
                                        unsigned char addr,\
                                        unsigned char *Name,\
                                        bool crc,\
                                        int *error);
/*         
         :
        porthandle -    -.
        addr -   
        *Name -  ,   
        crc -       .
         :
        *error -    ,       
*/
/*******************************************************************************************************************************************/
          void	  DLL_EXP	  TADCReadAnalog(int porthandle,\
                                        unsigned char addr,\
                                        signed short int *Values,\
                                        unsigned char StChan,\
                                        unsigned char EndChan,\
                                        unsigned char *ReadChanns,\
                                        bool crc,\
                                        int *error);


/*******************************************************************************************************************************************/
          void	DLL_EXP  ADCSetIntellect(int porthandle,\
                                        unsigned char addr,\
                                        unsigned char NUst,\
                                        unsigned char NChan,\
                                        short int AValue,\
                                        unsigned char Mode,\
                                        unsigned char DPort,\
                                        unsigned char Dbit,\
                                        bool OnOff,\
                                        bool crc,\
                                        int *error);
/*******************************************************************************************************************************************/
          void	DLL_EXP	  ADCEnableIntellect(int porthandle,\
                                        unsigned char addr,\
                                        bool OnOff,\
                                        bool SaveToEE,\
                                        bool crc,\
                                        int *error);
/*******************************************************************************************************************************************/

          void DLL_EXP	  ADCClearAllIntellect(int porthandle,\
                                        unsigned char addr,\
                                        bool crc,\
                                        int *error);
/*******************************************************************************************************************************************/
         void	DLL_EXP	  ADCIntellectUstavkaEnable(int porthandle,\
                                        unsigned char addr,\
                                        unsigned char NUst,\
                                        bool Enable,\
                                        bool crc,\
                                        int *error);
/*******************************************************************************************************************************************/
          void	DLL_EXP	  ADCGetIntellect(int porthandle,\
                                        unsigned char addr,\
                                        unsigned char *NUst,\
                                        unsigned char *NChan,\
                                        short int *AValue,\
                                        unsigned char *Mode,\
                                        unsigned char *DPort,\
                                        unsigned char *Dbit,\
                                        bool *OnOff,\
                                        bool *Enable,\
                                        bool *Empty,\
                                        bool crc,\
                                        int *error);
/*******************************************************************************************************************************************/
          void	DLL_EXP	 ADCChangeAddrBaud(int porthandle,\
                                        unsigned char addr,\
                                        unsigned char NewAddr,\
                                        DWORD NewBaud,\
                                        bool CheckSumOn,\
                                        bool crc,\
                                        int *error);
/*         .
         ,  ,  ,      :
         :
        porthandle -    -.
        addr -   
        NewAddr   -   
        NewBaud   -   
        CheckSumOn  -    .
        crc -       .
         :
        *error -    ,       

*/

/*******************************************************************************************************************************************/
/***************************************- TCON-DIO****************************************************************************************/
          void	 DLL_EXP	 DIOSetDO(int porthandle,\
                                        unsigned char addr,\
                                        unsigned char *DO,\
                                        bool crc,\
                                        int *error);
/*         :
         :
        porthandle -    -.
        addr -  
        *DO -    [4] (A,B,C,D) ,     (0-255);
        crc -     .
         :
        *error -    ,       

*/
/*******************************************************************************************************************************************/
          void	 DLL_EXP	 DIOReadDI(int porthandle,\
                                        unsigned char addr,\
                                        unsigned char *DI,\
                                        bool crc,\
                                        int *error);
/*         :
         :
        porthandle -    -.
        addr -  
        crc -     .
         :
        *DI -    [4] (A,B,C,D),    
        *error -    ,       

*/
/*******************************************************************************************************************************************/
          void	DLL_EXP	 DIORetDIDOCfg(int porthandle,\
                                        unsigned char addr,\
                                        unsigned char *DCfg,\
                                        bool crc,\
                                        int *error);
/*          / :
         :
        porthandle -    -.
        addr -  
        crc -     .
         :
        *DCfg -    [4] (A,B,C,D),      ( -. 0-, 1-)
        *error -    ,       

*/
/*******************************************************************************************************************************************/
void MBDiagnosticResult(int porthandle,\
                                        unsigned char addr,\
                                        unsigned char SF,\
                                        unsigned int *Result,\
                                        bool crc,\
                                        int *error);
/*        8  MODBUS.
         :
        porthandle -    -.
        addr -  
        SF -  
        crc -     .
         :
        *Result-      
        *error -    ,       
*/
//********************************************************************

}//extern C
//********************************************************************

 #endif
